﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	import flash.display.StageScaleMode;
	import flash.display.StageAlign;
	import flash.geom.ColorTransform;
	import flash.display.DisplayObject;
	
	import com.actionscriptfacile.ui.text.UITextField;

	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0x02313B")] 

	public class Main extends Sprite
	{
		private var oBackground : Sprite;
		private var oBtnStartGame : DefaultButton;
		
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6 et l'API du Player Flash 11.5
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start clic droit");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{
			oBackground = new Sprite();
			oBackground.graphics.beginFill(0xffffff);
			oBackground.graphics.drawRect(30, 30, stage.stageWidth - 60, stage.stageHeight - 60);
			oBackground.graphics.endFill();
			this.addChild(oBackground);

			// affichage d'un champ texte
			var oText:UITextField = this.addText("Effectuer un clique droit pour des actions supplémentaires.");
			oText.x = (stage.stageWidth - oText.width) /2;
			oText.y = (stage.stageHeight - oText.height) /2;
			this.addChild(oText);
		
		
			// Création du bouton pour le menu contextuel
			oBtnStartGame = new DefaultButton();
			oBtnStartGame.getObject().label = "Nouvelle Couleur !";
			oBtnStartGame.getObject().x = (stage.stageWidth - oBtnStartGame.width) /2;;
			oBtnStartGame.getObject().y = oText.y + oText.height + 20;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onChangeColor );
			oBtnStartGame.getObject().hide();
			this.addChild(oBtnStartGame);
			
			
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			
			// écouteurs d'évènements pour modifier le menu contextuel de flash
			stage.addEventListener(MouseEvent.RIGHT_MOUSE_DOWN, onMouseRightClick);
            stage.addEventListener(MouseEvent.RIGHT_MOUSE_UP, onMouseRightClick);
            stage.addEventListener(MouseEvent.MOUSE_UP, onMouseRightClick);
            stage.addEventListener(Event.MOUSE_LEAVE, onMouseLeaveScreen);
		}
		
		
		
		
		/**
		 * Clic droit sur la souris.
		 * 
		 */
        private function onMouseRightClick(event:MouseEvent):void
        {
			// en fonction du clic de la souris, des actions différentes sur l'application
            switch (event.type)
            {
                case MouseEvent.RIGHT_MOUSE_DOWN:   
						MonsterDebugger.trace(this, "Right Mouse Down");
						
                        break;

                case MouseEvent.RIGHT_MOUSE_UP:
						MonsterDebugger.trace(this, "Right Mouse Up");
						
						// création du menu contextuel...
						oBtnStartGame.getObject().x = mouseX;
						oBtnStartGame.getObject().y = mouseY;
						oBtnStartGame.getObject().show();
						break;
						
				case MouseEvent.MOUSE_UP:
						// masque le menu contextuel
						oBtnStartGame.getObject().hide();
						break;			
			
            }
        }
		
		

        /**
         * La souris quitte l'écran de l'application flash.
         * 
         */
        private function onMouseLeaveScreen(event:Event):void
        {
            MonsterDebugger.trace(this, "Mouse Leave");
			this.changeColor(oBackground);
        }
		
		

		/**
		 * Appel lors du clic sur le bouton du menu contextuel.
		 * 
		 */
		private function onChangeColor(event : MouseEvent) : void 
		{
			this.changeColor(oBackground);
		}
		
		
		/**
		 * Change aléatoirement la couleur d'un display object.
		 * 
		 */
		private function changeColor(oDisplay:DisplayObject) : void
		{
			// définit les couleurs primaires aléatoirement
			var red:int = int(Math.random() * 255);
			var green:int = int(Math.random() * 255);
			var blue:int = int(Math.random() * 255);
 
 			// construit la valeur hexadécimale
			var hexValue:Number = Number("0x" + red.toString(16) + green.toString(16) + blue.toString(16));
 			
			// applique la couleur au Display Object
			var colorTransform:ColorTransform = new ColorTransform();
			colorTransform.color = hexValue;
			oDisplay.transform.colorTransform = colorTransform;
		}

		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 18);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
	}
}
